/** @preserve Eloquence WEBDLG v2
 (C) Copyright Marxmeier Software AG, 2020-2022
 Version: 1.981 2022-05-09
 $Id: 00-load.js,v 28.32 2022/05/09 11:32:35 mike Exp $
*//*======================================================================
   WEBDLG v2 namespace
========================================================================*/

var eq = {};

/*========================================================================
   Load main thread script or handle page redirection.
========================================================================*/

(function() {
   // Check page URL for query string app= parameter.
   var wl = window.location, url = wl.href, app, ws;
   try {
      app = /[?&]app=([^&#]+)/i.exec(url)[1];
   } catch (e) {}
   if (app) {
      // Query string app= parameter specified, override application.
      (ws = window.sessionStorage).setItem('eq-webdlg.app', app);
      // Initialize user agent tag and session id.
      ws.removeItem('eq-webdlg.uat');
      ws.removeItem('eq-webdlg.sid');
      // Reload page wo/ query string app= parameter.
      eq.redirected = true;
      wl.replace((function(u) {
         var
            r = /^([^?#]+)([?][^#]*)?(#.*)?$/.exec(u),
            q = r[2];
         if (q) {
            var re = new RegExp('([?&])app=[^&#]*', 'i');
            if (q.match(re)) {
               q = q.replace(re, '');
               if (q.length && q.charAt(0) === '&')
                  q = q.replace('&', '?');
            }
         }
         u = r[1];
         if (q)
            u += q;
         if (r[3])
            u += r[3];
         return u;
      })(url));
   }
   else {
      // Load eq-webdlg-ui.js script.
      try {
         // Obtain script base URI from script URI.
         url = document.querySelector('script#eq-webdlg').src;
         var
            p = /^([^?#]+\/)[^/?#]+/.exec(url)[1],
            sc = document.createElement('SCRIPT');
         sc.src = p + "eq-webdlg-ui.js";
         sc.async = true;
         document.head.appendChild(sc);
      }
      catch (e) {
         throw new Error("WEBDLG: <script id=\"eq-webdlg\"> not found");
      }
   }
})();

/*========================================================================
   Plugin declaration interface.
========================================================================*/

eq.plugin = function(name, decl) {
   var m = this.plugin.m;
   if (m === undefined)
      m = this.plugin.m = new Map();
   m.set(name, decl);
};

/*------------------------------------------------------------------------
   Plugin attribute descriptor flags.
------------------------------------------------------------------------*/

eq.atrGET = 1;  // DLG GET attribute
eq.atrSET = 2;  // DLG SET attribute
eq.atrIDX = 4;  // May be indexed
eq.atrINT = 8;  // Data type: INTEGER
eq.atrSTR = 16; // Data type: STRING

/*========================================================================
   Strings registration.
========================================================================*/

eq.strings = function(strings, locale) {
   var m = this.strings.m, lv, l;
   if (m === undefined)
      m = this.strings.m = new Map();
   if (locale) {
      if ((lv = locale.split('-')).length > 1 && !m.has(l = lv[0]))
         m.set(l, strings);
      m.set(locale, strings);
   }
   else
      m.set('default', strings);
};

